/* A Bison parser, made by GNU Bison 2.1.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 1

/* Substitute the variable and function names.  */
#define yyparse tellparse
#define yylex   telllex
#define yyerror tellerror
#define yylval  telllval
#define yychar  tellchar
#define yydebug telldebug
#define yynerrs tellnerrs
#define yylloc telllloc

/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     tknERROR = 258,
     tknIF = 259,
     tknELSE = 260,
     tknWHILE = 261,
     tknREPEAT = 262,
     tknUNTIL = 263,
     tknSTRUCTdef = 264,
     tknVOIDdef = 265,
     tknREALdef = 266,
     tknBOOLdef = 267,
     tknINTdef = 268,
     tknPOINTdef = 269,
     tknBOXdef = 270,
     tknSTRINGdef = 271,
     tknLAYOUTdef = 272,
     tknLISTdef = 273,
     tknRETURN = 274,
     tknTRUE = 275,
     tknFALSE = 276,
     tknLEQ = 277,
     tknGEQ = 278,
     tknEQ = 279,
     tknNEQ = 280,
     tknAND = 281,
     tknOR = 282,
     tknSW = 283,
     tknSE = 284,
     tknNE = 285,
     tknNW = 286,
     tknIDENTIFIER = 287,
     tknFIELD = 288,
     tknSTRING = 289,
     tknREAL = 290,
     tknINT = 291
   };
#endif
/* Tokens.  */
#define tknERROR 258
#define tknIF 259
#define tknELSE 260
#define tknWHILE 261
#define tknREPEAT 262
#define tknUNTIL 263
#define tknSTRUCTdef 264
#define tknVOIDdef 265
#define tknREALdef 266
#define tknBOOLdef 267
#define tknINTdef 268
#define tknPOINTdef 269
#define tknBOXdef 270
#define tknSTRINGdef 271
#define tknLAYOUTdef 272
#define tknLISTdef 273
#define tknRETURN 274
#define tknTRUE 275
#define tknFALSE 276
#define tknLEQ 277
#define tknGEQ 278
#define tknEQ 279
#define tknNEQ 280
#define tknAND 281
#define tknOR 282
#define tknSW 283
#define tknSE 284
#define tknNE 285
#define tknNW 286
#define tknIDENTIFIER 287
#define tknFIELD 288
#define tknSTRING 289
#define tknREAL 290
#define tknINT 291




/* Copy the first part of user declarations.  */
#line 40 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"

#include <sstream>
#include "tellyzer.h"
#include "ted_prompt.h"
#include "../tpd_common/outbox.h"
/* Switch on verbose error reporting messages*/
#define YYERROR_VERBOSE 1
/*Current command block - defined in tellyzer.cpp*/
extern parsercmd::cmdBLOCK*       CMDBlock;
/*Global console object*/
extern console::ted_cmd*           Console;
/*Argument list structure used in function definitions*/
parsercmd::argumentLIST  *arglist = NULL;
/*Current tell variable name*/
telldata::tell_var *tellvar = NULL;
telldata::tell_var *tell_lvalue = NULL;
/*Current tell struct */
telldata::tell_type *tellstruct = NULL;
/* used for argument type checking during function call parse */
telldata::argumentQ   *argmap  = NULL;
/*taking care when a function is called from the argument list of another call*/
std::stack<telldata::argumentQ*>  argmapstack;
/* current function type (during function declaration/definition)*/
telldata::typeID funcretype;
/* current function name (during function declaration/definition)*/
char* funcname;
/*number of return statements encountered*/
int returns = 0;
/*number of errors in a function defintion*/
int funcdeferrors = 0;
/*number of poits of the current polygon*/
unsigned listlength = 0;
void tellerror(std::string s, parsercmd::yyltype loc);
void tellerror (std::string s);



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 165 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
typedef union YYSTYPE {
   float                    real;
   bool                     ptypedef;
   int                      integer;
   char                    *parsestr;
    telldata::typeID        pttname;
   parsercmd::argumentLIST *pfarguments;
    telldata::argumentQ    *plarguments;
    telldata::argumentID   *parguments;
   parsercmd::cmdBLOCK     *pblock;
   parsercmd::cmdFUNC      *pfblock;
} YYSTYPE;
/* Line 196 of yacc.c.  */
#line 215 "tell_yacc.cc"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif

#if ! defined (YYLTYPE) && ! defined (YYLTYPE_IS_DECLARED)
typedef struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
} YYLTYPE;
# define yyltype YYLTYPE /* obsolescent; will be withdrawn */
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


/* Copy the second part of user declarations.  */


/* Line 219 of yacc.c.  */
#line 239 "tell_yacc.cc"

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T) && (defined (__STDC__) || defined (__cplusplus))
# include <stddef.h> /* INFRINGES ON USER NAME SPACE */
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

#if ! defined (yyoverflow) || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if defined (__STDC__) || defined (__cplusplus)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     define YYINCLUDED_STDLIB_H
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2005 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM ((YYSIZE_T) -1)
#  endif
#  ifdef __cplusplus
extern "C" {
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if (! defined (malloc) && ! defined (YYINCLUDED_STDLIB_H) \
	&& (defined (__STDC__) || defined (__cplusplus)))
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if (! defined (free) && ! defined (YYINCLUDED_STDLIB_H) \
	&& (defined (__STDC__) || defined (__cplusplus)))
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifdef __cplusplus
}
#  endif
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (defined (YYLTYPE_IS_TRIVIAL) && YYLTYPE_IS_TRIVIAL \
             && defined (YYSTYPE_IS_TRIVIAL) && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short int yyss;
  YYSTYPE yyvs;
    YYLTYPE yyls;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short int) + sizeof (YYSTYPE) + sizeof (YYLTYPE))	\
      + 2 * YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined (__GNUC__) && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short int yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  66
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   287

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  50
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  50
/* YYNRULES -- Number of rules. */
#define YYNRULES  110
/* YYNRULES -- Number of states. */
#define YYNSTATES  173

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   291

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      38,    39,    48,    46,    43,    47,     2,    49,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,    37,
      44,    42,    45,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    40,     2,    41,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short int yyprhs[] =
{
       0,     0,     3,     5,     8,    11,    13,    16,    18,    20,
      21,    28,    31,    32,    37,    38,    43,    45,    48,    54,
      62,    63,    64,    72,    73,    81,    83,    87,    88,    90,
      92,    94,    96,    98,   100,   102,   104,   105,   111,   112,
     117,   118,   120,   122,   124,   126,   128,   130,   134,   135,
     137,   139,   143,   146,   148,   150,   152,   154,   157,   160,
     162,   165,   167,   169,   171,   173,   175,   177,   179,   181,
     183,   184,   191,   193,   197,   200,   201,   206,   209,   211,
     215,   217,   221,   223,   227,   231,   233,   237,   241,   245,
     249,   251,   255,   259,   263,   267,   271,   275,   277,   281,
     285,   287,   290,   292,   294,   296,   298,   300,   302,   304,
     308
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      51,     0,    -1,    52,    -1,    51,    52,    -1,    68,    37,
      -1,    55,    -1,    53,    37,    -1,     3,    -1,     1,    -1,
      -1,    83,    32,    38,    54,    76,    39,    -1,    53,    58,
      -1,    -1,    40,    57,    67,    41,    -1,    -1,    40,    59,
      67,    41,    -1,    19,    -1,    19,    74,    -1,     4,    38,
      92,    39,    56,    -1,     4,    38,    92,    39,    56,     5,
      56,    -1,    -1,    -1,     6,    38,    63,    92,    39,    64,
      56,    -1,    -1,     7,    56,     8,    38,    66,    92,    39,
      -1,    68,    -1,    67,    37,    68,    -1,    -1,    81,    -1,
      71,    -1,    61,    -1,    62,    -1,    65,    -1,    60,    -1,
      69,    -1,    85,    -1,    -1,    32,    38,    70,    73,    39,
      -1,    -1,    79,    42,    72,    74,    -1,    -1,    75,    -1,
      69,    -1,    92,    -1,    71,    -1,    89,    -1,    74,    -1,
      75,    43,    74,    -1,    -1,    77,    -1,    78,    -1,    77,
      43,    78,    -1,    83,    32,    -1,    80,    -1,    81,    -1,
      32,    -1,    88,    -1,    83,    32,    -1,    83,    32,    -1,
      84,    -1,    84,    18,    -1,    10,    -1,    11,    -1,    13,
      -1,    12,    -1,    14,    -1,    15,    -1,    16,    -1,    17,
      -1,    32,    -1,    -1,     9,    32,    86,    40,    87,    41,
      -1,    82,    -1,    87,    37,    82,    -1,    80,    33,    -1,
      -1,    40,    90,    75,    41,    -1,    83,    89,    -1,    93,
      -1,    92,    27,    93,    -1,    94,    -1,    93,    26,    94,
      -1,    95,    -1,    94,    24,    95,    -1,    94,    25,    95,
      -1,    96,    -1,    95,    44,    96,    -1,    95,    45,    96,
      -1,    95,    22,    96,    -1,    95,    23,    96,    -1,    97,
      -1,    96,    46,    97,    -1,    96,    47,    97,    -1,    96,
      30,    97,    -1,    96,    31,    97,    -1,    96,    29,    97,
      -1,    96,    28,    97,    -1,    98,    -1,    97,    48,    98,
      -1,    97,    49,    98,    -1,    99,    -1,    47,    99,    -1,
      35,    -1,    36,    -1,    20,    -1,    21,    -1,    34,    -1,
      80,    -1,    91,    -1,    38,    92,    39,    -1,     3,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short int yyrline[] =
{
       0,   203,   203,   204,   208,   212,   213,   218,   219,   223,
     223,   239,   259,   259,   270,   270,   281,   293,   309,   314,
     321,   325,   321,   336,   336,   352,   353,   357,   358,   359,
     360,   361,   362,   363,   364,   365,   369,   369,   390,   390,
     400,   401,   405,   406,   407,   408,   412,   413,   417,   418,
     422,   423,   427,   435,   436,   440,   446,   450,   463,   476,
     477,   481,   482,   483,   484,   485,   486,   487,   488,   489,
     500,   500,   517,   518,   522,   532,   532,   556,   569,   570,
     574,   575,   579,   580,   581,   585,   586,   587,   588,   589,
     593,   594,   595,   596,   597,   598,   599,   603,   604,   605,
     609,   610,   614,   616,   618,   620,   622,   625,   627,   629,
     630
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "tknERROR", "tknIF", "tknELSE",
  "tknWHILE", "tknREPEAT", "tknUNTIL", "tknSTRUCTdef", "tknVOIDdef",
  "tknREALdef", "tknBOOLdef", "tknINTdef", "tknPOINTdef", "tknBOXdef",
  "tknSTRINGdef", "tknLAYOUTdef", "tknLISTdef", "tknRETURN", "tknTRUE",
  "tknFALSE", "tknLEQ", "tknGEQ", "tknEQ", "tknNEQ", "tknAND", "tknOR",
  "tknSW", "tknSE", "tknNE", "tknNW", "tknIDENTIFIER", "tknFIELD",
  "tknSTRING", "tknREAL", "tknINT", "';'", "'('", "')'", "'{'", "'}'",
  "'='", "','", "'<'", "'>'", "'+'", "'-'", "'*'", "'/'", "$accept",
  "input", "entrance", "funcdeclaration", "@1", "funcdefinition", "block",
  "@2", "funcblock", "@3", "returnstatement", "ifstatement",
  "whilestatement", "@4", "@5", "repeatstatement", "@6", "statements",
  "statement", "funccall", "@7", "assignment", "@8", "arguments",
  "argument", "nearguments", "funcarguments", "funcneargument",
  "funcargument", "lvalue", "variable", "variabledeclaration",
  "fielddeclaration", "telltypeID", "telltype", "recorddefinition", "@9",
  "typedefstruct", "fieldname", "structure", "@10", "anonymousvar",
  "expression", "andexpression", "eqexpression", "relexpression",
  "addexpression", "multiexpression", "unaryexpression",
  "primaryexpression", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short int yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,    59,    40,    41,
     123,   125,    61,    44,    60,    62,    43,    45,    42,    47
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    50,    51,    51,    52,    52,    52,    52,    52,    54,
      53,    55,    57,    56,    59,    58,    60,    60,    61,    61,
      63,    64,    62,    66,    65,    67,    67,    68,    68,    68,
      68,    68,    68,    68,    68,    68,    70,    69,    72,    71,
      73,    73,    74,    74,    74,    74,    75,    75,    76,    76,
      77,    77,    78,    79,    79,    80,    80,    81,    82,    83,
      83,    84,    84,    84,    84,    84,    84,    84,    84,    84,
      86,    85,    87,    87,    88,    90,    89,    91,    92,    92,
      93,    93,    94,    94,    94,    95,    95,    95,    95,    95,
      96,    96,    96,    96,    96,    96,    96,    97,    97,    97,
      98,    98,    99,    99,    99,    99,    99,    99,    99,    99,
      99
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     1,     2,     2,     1,     2,     1,     1,     0,
       6,     2,     0,     4,     0,     4,     1,     2,     5,     7,
       0,     0,     7,     0,     7,     1,     3,     0,     1,     1,
       1,     1,     1,     1,     1,     1,     0,     5,     0,     4,
       0,     1,     1,     1,     1,     1,     1,     3,     0,     1,
       1,     3,     2,     1,     1,     1,     1,     2,     2,     1,
       2,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       0,     6,     1,     3,     2,     0,     4,     2,     1,     3,
       1,     3,     1,     3,     3,     1,     3,     3,     3,     3,
       1,     3,     3,     3,     3,     3,     3,     1,     3,     3,
       1,     2,     1,     1,     1,     1,     1,     1,     1,     3,
       1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       0,     8,     7,     0,     0,     0,     0,    61,    62,    64,
      63,    65,    66,    67,    68,    16,    55,     0,     2,     0,
       5,    33,    30,    31,    32,     0,    34,    29,     0,    53,
      28,     0,    59,    35,    56,     0,    20,    12,     0,    70,
     110,   104,   105,   106,   102,   103,     0,    75,     0,    42,
      44,    17,   107,    54,     0,    45,   108,    43,    78,    80,
      82,    85,    90,    97,   100,    36,     1,     3,     6,    14,
      11,     4,    38,    74,    57,    60,    55,   107,     0,     0,
       0,    27,     0,     0,     0,     0,   101,    57,    77,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    40,    27,     0,     9,     0,
       0,     0,    25,     0,    23,     0,   109,    46,     0,    79,
      81,    83,    84,    88,    89,    86,    87,    96,    95,    93,
      94,    91,    92,    98,    99,     0,    41,     0,    39,    48,
      18,    21,    27,    13,     0,    69,    72,     0,     0,    76,
       0,    37,    15,     0,    49,    50,     0,     0,     0,    26,
       0,    58,     0,    71,    47,    10,     0,    52,    19,    22,
      24,    73,    51
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short int yydefgoto[] =
{
      -1,    17,    18,    19,   139,    20,    38,    81,    70,   106,
      21,    22,    23,    80,   158,    24,   144,   111,    25,    26,
     105,    27,   107,   135,   117,   118,   153,   154,   155,    28,
      77,    30,   146,    78,    32,    33,    83,   148,    34,    55,
      85,    56,    57,    58,    59,    60,    61,    62,    63,    64
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -103
static const short int yypact[] =
{
     215,  -103,  -103,    49,    58,     1,    42,  -103,  -103,  -103,
    -103,  -103,  -103,  -103,  -103,    11,    12,   183,  -103,   -24,
    -103,  -103,  -103,  -103,  -103,    31,  -103,  -103,    78,    50,
      96,   103,   125,  -103,  -103,   144,  -103,  -103,   138,  -103,
    -103,  -103,  -103,  -103,  -103,  -103,   144,  -103,   243,  -103,
    -103,  -103,    34,  -103,    46,  -103,  -103,   124,   126,    65,
      15,    33,   -38,  -103,  -103,  -103,  -103,  -103,  -103,  -103,
    -103,  -103,  -103,  -103,   129,  -103,    -6,    50,   123,     9,
     144,   112,   130,   131,    27,    11,  -103,  -103,  -103,   144,
     144,   144,   144,   144,   144,   144,   144,   144,   144,   144,
     144,   144,   144,   144,   144,    11,   112,    11,  -103,     1,
      30,    -2,  -103,   137,  -103,   255,  -103,  -103,    -1,   126,
      65,    15,    15,    33,    33,    33,    33,   -38,   -38,   -38,
     -38,   -38,   -38,  -103,  -103,   133,   127,    36,  -103,   255,
     168,  -103,   112,  -103,   144,  -103,  -103,   142,    93,  -103,
      11,  -103,  -103,   136,   134,  -103,   149,     1,     1,  -103,
      43,  -103,   255,  -103,  -103,  -103,   255,  -103,  -103,  -103,
    -103,  -103,  -103
};

/* YYPGOTO[NTERM-NUM].  */
static const short int yypgoto[] =
{
    -103,  -103,   171,  -103,  -103,  -103,  -102,  -103,  -103,  -103,
    -103,  -103,  -103,  -103,  -103,  -103,  -103,    79,   -77,   -14,
    -103,   -13,  -103,  -103,    -9,    98,  -103,  -103,    35,  -103,
       3,   -10,    44,     0,  -103,  -103,  -103,  -103,  -103,   -45,
    -103,  -103,   -27,   115,   117,    41,    18,     2,    45,   157
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -70
static const short int yytable[] =
{
      31,    49,    50,    29,   112,    53,    51,   140,    79,    88,
     103,   104,   -69,    68,    40,    54,    69,    31,    52,    84,
      29,     7,     8,     9,    10,    11,    12,    13,    14,   112,
     -69,    41,    42,    88,   -69,   142,    89,    93,    94,   143,
     149,    37,   150,    16,   -69,    43,    44,    45,   109,    46,
      65,    47,   -69,   110,    89,   168,   169,    89,    48,    95,
      96,    97,    98,    99,   100,   159,   116,    73,    71,   141,
      89,    49,    50,   142,    39,    53,   -53,   152,    87,   101,
     102,   113,   170,    73,    29,    54,    47,    35,    52,    91,
      92,    49,    50,    49,    50,    53,    36,    53,   138,   127,
     128,   129,   130,   131,   132,    54,   113,    54,    52,    29,
      52,   123,   124,   125,   126,   147,     3,   160,     4,     5,
      72,     6,     7,     8,     9,    10,    11,    12,    13,    14,
     162,    15,   121,   122,   163,    74,    49,    50,   -54,   156,
      53,   164,   113,    75,    16,    29,    82,    40,   133,   134,
      54,    89,    90,    52,     7,     8,     9,    10,    11,    12,
      13,    14,   147,    47,    41,    42,   156,   108,   114,    87,
     150,   115,   151,   157,   161,   165,    76,   166,    43,    44,
      45,   167,    46,    66,     1,   137,     2,     3,    67,     4,
       5,    48,     6,     7,     8,     9,    10,    11,    12,    13,
      14,   172,    15,   136,   119,    86,   171,   120,     0,     0,
       0,     0,     0,     0,     0,    16,     1,     0,     2,     3,
     -27,     4,     5,     0,     6,     7,     8,     9,    10,    11,
      12,    13,    14,     0,    15,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    40,    16,     0,     0,
       0,     0,   -27,     7,     8,     9,    10,    11,    12,    13,
      14,     0,     0,    41,    42,     7,     8,     9,    10,    11,
      12,    13,    14,     0,     0,    76,     0,    43,    44,    45,
       0,    46,     0,     0,     0,     0,     0,   145
};

static const short int yycheck[] =
{
       0,    15,    15,     0,    81,    15,    15,   109,    35,    54,
      48,    49,    18,    37,     3,    15,    40,    17,    15,    46,
      17,    10,    11,    12,    13,    14,    15,    16,    17,   106,
      18,    20,    21,    78,    40,    37,    27,    22,    23,    41,
      41,    40,    43,    32,    32,    34,    35,    36,    39,    38,
      38,    40,    40,    80,    27,   157,   158,    27,    47,    44,
      45,    28,    29,    30,    31,   142,    39,    33,    37,    39,
      27,    85,    85,    37,    32,    85,    42,    41,    32,    46,
      47,    81,    39,    33,    81,    85,    40,    38,    85,    24,
      25,   105,   105,   107,   107,   105,    38,   107,   107,    97,
      98,    99,   100,   101,   102,   105,   106,   107,   105,   106,
     107,    93,    94,    95,    96,   115,     4,   144,     6,     7,
      42,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      37,    19,    91,    92,    41,    32,   150,   150,    42,   139,
     150,   150,   142,    18,    32,   142,     8,     3,   103,   104,
     150,    27,    26,   150,    10,    11,    12,    13,    14,    15,
      16,    17,   162,    40,    20,    21,   166,    38,    38,    32,
      43,    40,    39,     5,    32,    39,    32,    43,    34,    35,
      36,    32,    38,     0,     1,   106,     3,     4,    17,     6,
       7,    47,     9,    10,    11,    12,    13,    14,    15,    16,
      17,   166,    19,   105,    89,    48,   162,    90,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    32,     1,    -1,     3,     4,
      37,     6,     7,    -1,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    -1,    19,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     3,    32,    -1,    -1,
      -1,    -1,    37,    10,    11,    12,    13,    14,    15,    16,
      17,    -1,    -1,    20,    21,    10,    11,    12,    13,    14,
      15,    16,    17,    -1,    -1,    32,    -1,    34,    35,    36,
      -1,    38,    -1,    -1,    -1,    -1,    -1,    32
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,     1,     3,     4,     6,     7,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    19,    32,    51,    52,    53,
      55,    60,    61,    62,    65,    68,    69,    71,    79,    80,
      81,    83,    84,    85,    88,    38,    38,    40,    56,    32,
       3,    20,    21,    34,    35,    36,    38,    40,    47,    69,
      71,    74,    80,    81,    83,    89,    91,    92,    93,    94,
      95,    96,    97,    98,    99,    38,     0,    52,    37,    40,
      58,    37,    42,    33,    32,    18,    32,    80,    83,    92,
      63,    57,     8,    86,    92,    90,    99,    32,    89,    27,
      26,    24,    25,    22,    23,    44,    45,    28,    29,    30,
      31,    46,    47,    48,    49,    70,    59,    72,    38,    39,
      92,    67,    68,    83,    38,    40,    39,    74,    75,    93,
      94,    95,    95,    96,    96,    96,    96,    97,    97,    97,
      97,    97,    97,    98,    98,    73,    75,    67,    74,    54,
      56,    39,    37,    41,    66,    32,    82,    83,    87,    41,
      43,    39,    41,    76,    77,    78,    83,     5,    64,    68,
      92,    32,    37,    41,    74,    39,    43,    32,    56,    56,
      39,    82,    78
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (0)


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (N)								\
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (0)
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
              (Loc).first_line, (Loc).first_column,	\
              (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr,					\
                  Type, Value, Location);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short int *bottom, short int *top)
#else
static void
yy_stack_print (bottom, top)
    short int *bottom;
    short int *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu), ",
             yyrule - 1, yylno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname[yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname[yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      size_t yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

#endif /* YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep, yylocationp)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
    YYLTYPE *yylocationp;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;
  (void) yylocationp;

  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");

# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
#else
static void
yydestruct (yymsg, yytype, yyvaluep, yylocationp)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
    YYLTYPE *yylocationp;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;
  (void) yylocationp;

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The look-ahead symbol.  */
int yychar;

/* The semantic value of the look-ahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;
/* Location data for the look-ahead symbol.  */
YYLTYPE yylloc;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  int yystate;
  int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Look-ahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short int yyssa[YYINITDEPTH];
  short int *yyss = yyssa;
  short int *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  YYSTYPE *yyvsp;

  /* The location stack.  */
  YYLTYPE yylsa[YYINITDEPTH];
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;
  /* The locations where the error started and ended. */
  YYLTYPE yyerror_range[2];

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;
  yylsp = yyls;
#if YYLTYPE_IS_TRIVIAL
  /* Initialize the default location before parsing starts.  */
  yylloc.first_line   = yylloc.last_line   = 1;
  yylloc.first_column = yylloc.last_column = 0;
#endif

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short int *yyss1 = yyss;
	YYLTYPE *yyls1 = yyls;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);
	yyls = yyls1;
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short int *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);
	YYSTACK_RELOCATE (yyls);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a look-ahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to look-ahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a look-ahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid look-ahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the look-ahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
  *++yylsp = yylloc;

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location. */
  YYLLOC_DEFAULT (yyloc, yylsp - yylen, yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 203 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {}
    break;

  case 3:
#line 204 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {}
    break;

  case 4:
#line 208 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {
      if (!yynerrs)  CMDBlock->execute();
      else           CMDBlock = CMDBlock->cleaner();
   }
    break;

  case 5:
#line 212 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {}
    break;

  case 6:
#line 213 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {
//         CMDBlock->addUSERFUNCDECL(std::string($2),$1,arglist);
      arglist = NULL;
      delete [] funcname;
   }
    break;

  case 7:
#line 218 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {tellerror("Unexpected symbol", (yylsp[0]));}
    break;

  case 8:
#line 219 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {CMDBlock = CMDBlock->cleaner();/*yynerrs = 0;*/}
    break;

  case 9:
#line 223 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {
      /*Create a new variableMAP structure containing the arguments*/
      arglist = new parsercmd::argumentLIST;
      funcretype = (yyvsp[-2].pttname);returns = 0;funcdeferrors = 0;
      funcname = (yyvsp[-1].parsestr);
   }
    break;

  case 10:
#line 229 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {}
    break;

  case 11:
#line 239 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {
         if ((telldata::tn_void != funcretype) && (0 == returns)) {
            tellerror("function must return a value", (yyloc));
            delete((yyvsp[0].pfblock));// arglist is cleared by the cmdSTDFUNC destructor
         }
         else  if (funcdeferrors > 0) {
            tellerror("function definition is ignored because of the errors above", (yyloc));
            delete((yyvsp[0].pfblock));// arglist is cleared by the cmdSTDFUNC destructor
         }
         else {
            if (!CMDBlock->addUSERFUNC(std::string(funcname),(yyvsp[0].pfblock),arglist)) {
               delete ((yyvsp[0].pfblock));
            }
         }
         arglist = NULL;
         delete [] funcname;
   }
    break;

  case 12:
#line 259 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {
         CMDBlock = new parsercmd::cmdBLOCK();
         CMDBlock->pushblk();
      }
    break;

  case 13:
#line 263 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {
         (yyval.pblock) = CMDBlock;
         CMDBlock = CMDBlock->popblk();
      }
    break;

  case 14:
#line 270 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {
         CMDBlock = new parsercmd::cmdFUNC(arglist,funcretype);
         CMDBlock->pushblk();
      }
    break;

  case 15:
#line 274 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {
         (yyval.pfblock) = static_cast<parsercmd::cmdFUNC*>(CMDBlock);
         CMDBlock = CMDBlock->popblk();
      }
    break;

  case 16:
#line 281 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {
      if      (!arglist) tellerror("return statement outside function body", (yylsp[0]));
      else {
         parsercmd::cmdRETURN* rcmd = new parsercmd::cmdRETURN(funcretype);
         if (rcmd->checkRetype(NULL)) CMDBlock->pushcmd(rcmd);
         else {
            tellerror("return value expected", (yylsp[0]));
            delete rcmd;
         }
      }
      returns++;
   }
    break;

  case 17:
#line 293 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {
      if (!arglist) tellerror("return statement outside function body", (yylsp[-1]));
      else {
         parsercmd::cmdRETURN* rcmd = new parsercmd::cmdRETURN(funcretype);
         if (rcmd->checkRetype((yyvsp[0].parguments))) CMDBlock->pushcmd(rcmd);
         else {
            tellerror("return type different from function type", (yylsp[0]));
            delete rcmd;
         }
         delete (yyvsp[0].parguments);
      }
      returns++;
   }
    break;

  case 18:
#line 309 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {
         if (telldata::tn_bool != (yyvsp[-2].pttname)) tellerror("bool type expected",(yylsp[-2]));
         else CMDBlock->pushcmd(new parsercmd::cmdIFELSE((yyvsp[0].pblock), NULL));
      }
    break;

  case 19:
#line 314 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {
         if (telldata::tn_bool != (yyvsp[-4].pttname)) tellerror("bool type expected",(yylsp[-4]));
         else CMDBlock->pushcmd(new parsercmd::cmdIFELSE((yyvsp[-2].pblock),(yyvsp[0].pblock)));
      }
    break;

  case 20:
#line 321 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {
         CMDBlock = new parsercmd::cmdBLOCK();
         CMDBlock->pushblk();
      }
    break;

  case 21:
#line 325 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {
         if (telldata::tn_bool != (yyvsp[-1].pttname)) tellerror("bool type expected", (yylsp[-1]));
      }
    break;

  case 22:
#line 328 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {
         parsercmd::cmdBLOCK* condBlock = CMDBlock;
         CMDBlock = CMDBlock->popblk();
         CMDBlock->pushcmd(new parsercmd::cmdWHILE(condBlock,(yyvsp[0].pblock)));
   }
    break;

  case 23:
#line 336 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {
         CMDBlock = new parsercmd::cmdBLOCK();
         CMDBlock->pushblk();
      }
    break;

  case 24:
#line 340 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {
         parsercmd::cmdBLOCK* condBlock = CMDBlock;
         CMDBlock = CMDBlock->popblk();
         if (telldata::tn_bool != (yyvsp[-1].pttname)) {
            tellerror("bool type expected", (yylsp[-1]));
            delete condBlock;
         }
         else CMDBlock->pushcmd(new parsercmd::cmdREPEAT(condBlock,(yyvsp[-5].pblock)));
   }
    break;

  case 25:
#line 352 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {}
    break;

  case 26:
#line 353 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {}
    break;

  case 27:
#line 357 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    { }
    break;

  case 28:
#line 358 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    { }
    break;

  case 29:
#line 359 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {CMDBlock->pushcmd(new parsercmd::cmdSTACKRST());}
    break;

  case 30:
#line 360 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {CMDBlock->pushcmd(new parsercmd::cmdSTACKRST());}
    break;

  case 31:
#line 361 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {CMDBlock->pushcmd(new parsercmd::cmdSTACKRST());}
    break;

  case 32:
#line 362 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {CMDBlock->pushcmd(new parsercmd::cmdSTACKRST());}
    break;

  case 33:
#line 363 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {/*keep the return value in the stack*/}
    break;

  case 34:
#line 364 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {CMDBlock->pushcmd(new parsercmd::cmdSTACKRST());}
    break;

  case 35:
#line 365 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    { }
    break;

  case 36:
#line 369 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {
        argmap = new telldata::argumentQ;
        argmapstack.push(argmap);
   }
    break;

  case 37:
#line 373 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {
      parsercmd::cmdSTDFUNC *fc = CMDBlock->getFuncBody((yyvsp[-4].parsestr),(yyvsp[-1].plarguments));
      if (fc) {
         CMDBlock->pushcmd(new parsercmd::cmdFUNCCALL(fc,(yyvsp[-4].parsestr)));
         (yyval.pttname) = fc->gettype();
      }
      else tellerror("unknown function name or wrong parameter list",(yylsp[-4]));
      telldata::argQClear(argmap);
      argmapstack.pop();
      delete argmap;
      if (argmapstack.size() > 0) argmap = argmapstack.top();
      else argmap = NULL;
      delete [] (yyvsp[-4].parsestr);
   }
    break;

  case 38:
#line 390 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {tell_lvalue = tellvar;}
    break;

  case 39:
#line 391 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {
      /*because of the (possible) structure that has an unknown yet tn_usertypes type,
      here we are doing the type checking, using the type of the lvalue*/
      (yyval.pttname) = parsercmd::Assign(tell_lvalue, (yyvsp[0].parguments), (yylsp[-2]));
      delete (yyvsp[0].parguments);
   }
    break;

  case 40:
#line 400 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {(yyval.plarguments) = NULL;}
    break;

  case 41:
#line 401 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {(yyval.plarguments) = (yyvsp[0].plarguments);}
    break;

  case 42:
#line 405 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {(yyval.parguments) = new telldata::argumentID((yyvsp[0].pttname));}
    break;

  case 43:
#line 406 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {(yyval.parguments) = new telldata::argumentID((yyvsp[0].pttname));}
    break;

  case 44:
#line 407 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {(yyval.parguments) = new telldata::argumentID((yyvsp[0].pttname));}
    break;

  case 45:
#line 408 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {(yyval.parguments) = (yyvsp[0].parguments);}
    break;

  case 46:
#line 412 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {argmap->push_back((yyvsp[0].parguments)); (yyval.plarguments) = argmap;}
    break;

  case 47:
#line 413 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {argmap->push_back((yyvsp[0].parguments)); (yyval.plarguments) = argmap;}
    break;

  case 48:
#line 417 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {}
    break;

  case 49:
#line 418 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {}
    break;

  case 50:
#line 422 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {}
    break;

  case 51:
#line 423 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {}
    break;

  case 52:
#line 427 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {
      tellvar = CMDBlock->newTellvar((yyvsp[-1].pttname), (yylsp[-1]));
      arglist->push_back(new parsercmd::argumentTYPE((yyvsp[0].parsestr),tellvar));
      delete [] (yyvsp[0].parsestr);
   }
    break;

  case 53:
#line 435 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {(yyval.pttname) = (yyvsp[0].pttname);}
    break;

  case 54:
#line 436 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {(yyval.pttname) = (yyvsp[0].pttname);}
    break;

  case 55:
#line 440 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {
      tellvar = CMDBlock->getID((yyvsp[0].parsestr));
      if (tellvar) (yyval.pttname) = tellvar->get_type();
      else tellerror("variable not defined in this scope", (yylsp[0]));
      delete [] (yyvsp[0].parsestr);
   }
    break;

  case 56:
#line 446 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {(yyval.pttname) = (yyvsp[0].pttname);}
    break;

  case 57:
#line 450 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {(yyval.pttname) = (yyvsp[-1].pttname);
      telldata::tell_var* v = CMDBlock->getID((yyvsp[0].parsestr), true);
      if (!v) {/* if this variableID doesn't exist already in the local scope*/
         /* add it to the local variable map */
         tellvar = CMDBlock->newTellvar((yyvsp[-1].pttname), (yylsp[-1]));
         CMDBlock->addID((yyvsp[0].parsestr),tellvar); 
      }
      else tellerror("variable already defined in this scope", (yylsp[-1]));
      delete [] (yyvsp[0].parsestr);
   }
    break;

  case 58:
#line 463 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {
      const telldata::tell_type* ftype =
            CMDBlock->getTypeByID((yyvsp[-1].pttname) & ~telldata::tn_listmask);
      if (!tellstruct->addfield((yyvsp[0].parsestr), (yyvsp[-1].pttname), ftype)) {
         tellerror("field with this name already defined in this strucutre", (yylsp[0]));
         (yyval.ptypedef) = false; // indicates that definition fails
      }
      else (yyval.ptypedef) = true;
      delete [] (yyvsp[0].parsestr);
   }
    break;

  case 59:
#line 476 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {(yyval.pttname) = (yyvsp[0].pttname);}
    break;

  case 60:
#line 477 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {(yyval.pttname) = (yyvsp[-1].pttname) | telldata::tn_listmask;}
    break;

  case 61:
#line 481 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {(yyval.pttname) = telldata::tn_void;}
    break;

  case 62:
#line 482 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {(yyval.pttname) = telldata::tn_real;}
    break;

  case 63:
#line 483 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {(yyval.pttname) = telldata::tn_int;}
    break;

  case 64:
#line 484 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {(yyval.pttname) = telldata::tn_bool;}
    break;

  case 65:
#line 485 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {(yyval.pttname) = telldata::tn_pnt;}
    break;

  case 66:
#line 486 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {(yyval.pttname) = telldata::tn_box;}
    break;

  case 67:
#line 487 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {(yyval.pttname) = telldata::tn_string;}
    break;

  case 68:
#line 488 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {(yyval.pttname) = telldata::tn_layout;}
    break;

  case 69:
#line 489 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {
        const telldata::tell_type* ttype = CMDBlock->getTypeByName((yyvsp[0].parsestr));
        if (NULL == ttype)  {
           tellerror("Bad type specifier", (yylsp[0]));YYABORT;
        }
        else (yyval.pttname) = ttype->ID();
        delete [] (yyvsp[0].parsestr);
      }
    break;

  case 70:
#line 500 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {
        tellstruct = CMDBlock->requesttypeID((yyvsp[0].parsestr));
        if (NULL == tellstruct) {
           tellerror("type with this name already defined", (yylsp[-1]));
           delete [] (yyvsp[0].parsestr);
           YYABORT;
        }
     }
    break;

  case 71:
#line 508 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {
        if ((yyvsp[-1].ptypedef)) CMDBlock->addlocaltype((yyvsp[-4].parsestr),tellstruct);
        else delete tellstruct;
        tellstruct = NULL;
        delete [] (yyvsp[-4].parsestr);
     }
    break;

  case 72:
#line 517 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    { (yyval.ptypedef) = (yyvsp[0].ptypedef);      }
    break;

  case 73:
#line 518 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    { (yyval.ptypedef) = (yyvsp[-2].ptypedef) && (yyvsp[0].ptypedef);}
    break;

  case 74:
#line 522 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {
      assert(NULL != tellvar);
      tellvar = tellvar->field_var((yyvsp[0].parsestr));
      if (tellvar) (yyval.pttname) = tellvar->get_type();
      else tellerror("Bad field identifier", (yylsp[0]));
      delete [] (yyvsp[0].parsestr);
    }
    break;

  case 75:
#line 532 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {
        argmap = new telldata::argumentQ;
        argmapstack.push(argmap);
   }
    break;

  case 76:
#line 536 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {
        /*Important note!. Here we will get a list of components that could be
          a tell list or some kind of tell struct or even tell list of tell struct.
          There is no way at this moment to determine the type of the input structure
          for (seems) obvious reasons. So - the type check and the eventual pushcmd
          are postponed untill we get the recepient - i.e. the lvalue or the
          function call. $$ is assigned to argumentID, that caries the whole argument
          queue listed in structure*/
        parsercmd::cmdSTRUCT* struct_command = new parsercmd::cmdSTRUCT();
        CMDBlock->pushcmd(struct_command);
        (yyval.parguments) = new telldata::argumentID(argmap, struct_command);
        //argQClear(argmap);
        argmapstack.pop();
        delete argmap;
        if (argmapstack.size() > 0) argmap = argmapstack.top();
        else argmap = NULL;
   }
    break;

  case 77:
#line 556 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {
      // the structure is without a type at this moment, so here we do the type checking
      if (parsercmd::StructTypeCheck((yyvsp[-1].pttname), (yyvsp[0].parguments), (yylsp[0]))) {
         tellvar = CMDBlock->newTellvar((yyvsp[-1].pttname), (yylsp[-1]));
         (yyval.pttname) = (yyvsp[-1].pttname);
      }
      else tellerror("Type mismatch", (yylsp[0]));
   }
    break;

  case 78:
#line 569 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {(yyval.pttname) = (yyvsp[0].pttname);}
    break;

  case 79:
#line 570 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {(yyval.pttname) = parsercmd::BoolEx((yyvsp[-2].pttname),(yyvsp[0].pttname),"||",(yylsp[-2]),(yylsp[-1]));}
    break;

  case 80:
#line 574 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {(yyval.pttname) = (yyvsp[0].pttname);}
    break;

  case 81:
#line 575 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {(yyval.pttname) = parsercmd::BoolEx((yyvsp[-2].pttname),(yyvsp[0].pttname),"&&",(yylsp[-2]),(yylsp[-1]));}
    break;

  case 82:
#line 579 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {(yyval.pttname) = (yyvsp[0].pttname);}
    break;

  case 83:
#line 580 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {(yyval.pttname) = parsercmd::BoolEx((yyvsp[-2].pttname),(yyvsp[0].pttname),"==",(yylsp[-2]),(yylsp[-1]));}
    break;

  case 84:
#line 581 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {(yyval.pttname) = parsercmd::BoolEx((yyvsp[-2].pttname),(yyvsp[0].pttname),"!=",(yylsp[-2]),(yylsp[-1]));}
    break;

  case 85:
#line 585 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {(yyval.pttname) = (yyvsp[0].pttname);}
    break;

  case 86:
#line 586 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {(yyval.pttname) = parsercmd::BoolEx((yyvsp[-2].pttname),(yyvsp[0].pttname),"<",(yylsp[-2]),(yylsp[-1]));}
    break;

  case 87:
#line 587 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {(yyval.pttname) = parsercmd::BoolEx((yyvsp[-2].pttname),(yyvsp[0].pttname),">",(yylsp[-2]),(yylsp[-1]));}
    break;

  case 88:
#line 588 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {(yyval.pttname) = parsercmd::BoolEx((yyvsp[-2].pttname),(yyvsp[0].pttname),"<=",(yylsp[-2]),(yylsp[-1]));}
    break;

  case 89:
#line 589 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {(yyval.pttname) = parsercmd::BoolEx((yyvsp[-2].pttname),(yyvsp[0].pttname),">=",(yylsp[-2]),(yylsp[-1]));}
    break;

  case 90:
#line 593 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {(yyval.pttname) = (yyvsp[0].pttname);}
    break;

  case 91:
#line 594 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {(yyval.pttname) = parsercmd::Plus((yyvsp[-2].pttname),(yyvsp[0].pttname),(yylsp[-2]),(yylsp[0]));}
    break;

  case 92:
#line 595 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {(yyval.pttname) = parsercmd::Minus((yyvsp[-2].pttname),(yyvsp[0].pttname),(yylsp[-2]),(yylsp[0]));}
    break;

  case 93:
#line 596 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {(yyval.pttname) = parsercmd::PointMv((yyvsp[-2].pttname),(yyvsp[0].pttname),(yylsp[-2]),(yylsp[0]),+1,+1);}
    break;

  case 94:
#line 597 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {(yyval.pttname) = parsercmd::PointMv((yyvsp[-2].pttname),(yyvsp[0].pttname),(yylsp[-2]),(yylsp[0]),-1,+1);}
    break;

  case 95:
#line 598 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {(yyval.pttname) = parsercmd::PointMv((yyvsp[-2].pttname),(yyvsp[0].pttname),(yylsp[-2]),(yylsp[0]),+1,-1);}
    break;

  case 96:
#line 599 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {(yyval.pttname) = parsercmd::PointMv((yyvsp[-2].pttname),(yyvsp[0].pttname),(yylsp[-2]),(yylsp[0]),-1,-1);}
    break;

  case 97:
#line 603 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {(yyval.pttname) = (yyvsp[0].pttname);}
    break;

  case 98:
#line 604 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {(yyval.pttname) = parsercmd::Multiply((yyvsp[-2].pttname),(yyvsp[0].pttname),(yylsp[-2]),(yylsp[0]));}
    break;

  case 99:
#line 605 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {(yyval.pttname) = parsercmd::Divide((yyvsp[-2].pttname),(yyvsp[0].pttname),(yylsp[-2]),(yylsp[0]));}
    break;

  case 100:
#line 609 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {(yyval.pttname) = (yyvsp[0].pttname);}
    break;

  case 101:
#line 610 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {(yyval.pttname) = parsercmd::UMinus((yyvsp[0].pttname),(yylsp[0]));}
    break;

  case 102:
#line 614 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {(yyval.pttname) = telldata::tn_real;
      CMDBlock->pushcmd(new parsercmd::cmdPUSH(new telldata::ttreal((yyvsp[0].real)),true));}
    break;

  case 103:
#line 616 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {(yyval.pttname) = telldata::tn_int;
      CMDBlock->pushcmd(new parsercmd::cmdPUSH(new telldata::ttint((yyvsp[0].integer)),true));}
    break;

  case 104:
#line 618 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {(yyval.pttname) = telldata::tn_bool;
      CMDBlock->pushcmd(new parsercmd::cmdPUSH(new telldata::ttbool(true),true));}
    break;

  case 105:
#line 620 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {(yyval.pttname) = telldata::tn_bool;
      CMDBlock->pushcmd(new parsercmd::cmdPUSH(new telldata::ttbool(false),true));}
    break;

  case 106:
#line 622 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {(yyval.pttname) = telldata::tn_string;
      CMDBlock->pushcmd(new parsercmd::cmdPUSH(new telldata::ttstring((yyvsp[0].parsestr)),true));
                                                                delete [] (yyvsp[0].parsestr);}
    break;

  case 107:
#line 625 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {(yyval.pttname) = (yyvsp[0].pttname);
      CMDBlock->pushcmd(new parsercmd::cmdPUSH(tellvar));}
    break;

  case 108:
#line 627 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {(yyval.pttname) = (yyvsp[0].pttname);
      CMDBlock->pushcmd(new parsercmd::cmdPUSH(tellvar));}
    break;

  case 109:
#line 629 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {(yyval.pttname) = (yyvsp[-1].pttname);}
    break;

  case 110:
#line 630 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"
    {tellerror("Unexpected symbol", (yylsp[0]));}
    break;


      default: break;
    }

/* Line 1126 of yacc.c.  */
#line 2189 "tell_yacc.cc"

  yyvsp -= yylen;
  yyssp -= yylen;
  yylsp -= yylen;

  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  int yytype = YYTRANSLATE (yychar);
	  YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
	  YYSIZE_T yysize = yysize0;
	  YYSIZE_T yysize1;
	  int yysize_overflow = 0;
	  char *yymsg = 0;
#	  define YYERROR_VERBOSE_ARGS_MAXIMUM 5
	  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
	  int yyx;

#if 0
	  /* This is so xgettext sees the translatable formats that are
	     constructed on the fly.  */
	  YY_("syntax error, unexpected %s");
	  YY_("syntax error, unexpected %s, expecting %s");
	  YY_("syntax error, unexpected %s, expecting %s or %s");
	  YY_("syntax error, unexpected %s, expecting %s or %s or %s");
	  YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
#endif
	  char *yyfmt;
	  char const *yyf;
	  static char const yyunexpected[] = "syntax error, unexpected %s";
	  static char const yyexpecting[] = ", expecting %s";
	  static char const yyor[] = " or %s";
	  char yyformat[sizeof yyunexpected
			+ sizeof yyexpecting - 1
			+ ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
			   * (sizeof yyor - 1))];
	  char const *yyprefix = yyexpecting;

	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  int yyxbegin = yyn < 0 ? -yyn : 0;

	  /* Stay within bounds of both yycheck and yytname.  */
	  int yychecklim = YYLAST - yyn;
	  int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
	  int yycount = 1;

	  yyarg[0] = yytname[yytype];
	  yyfmt = yystpcpy (yyformat, yyunexpected);

	  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      {
		if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
		  {
		    yycount = 1;
		    yysize = yysize0;
		    yyformat[sizeof yyunexpected - 1] = '\0';
		    break;
		  }
		yyarg[yycount++] = yytname[yyx];
		yysize1 = yysize + yytnamerr (0, yytname[yyx]);
		yysize_overflow |= yysize1 < yysize;
		yysize = yysize1;
		yyfmt = yystpcpy (yyfmt, yyprefix);
		yyprefix = yyor;
	      }

	  yyf = YY_(yyformat);
	  yysize1 = yysize + yystrlen (yyf);
	  yysize_overflow |= yysize1 < yysize;
	  yysize = yysize1;

	  if (!yysize_overflow && yysize <= YYSTACK_ALLOC_MAXIMUM)
	    yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg)
	    {
	      /* Avoid sprintf, as that infringes on the user's name space.
		 Don't have undefined behavior even if the translation
		 produced a string with the wrong number of "%s"s.  */
	      char *yyp = yymsg;
	      int yyi = 0;
	      while ((*yyp = *yyf))
		{
		  if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		    {
		      yyp += yytnamerr (yyp, yyarg[yyi++]);
		      yyf += 2;
		    }
		  else
		    {
		      yyp++;
		      yyf++;
		    }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    {
	      yyerror (YY_("syntax error"));
	      goto yyexhaustedlab;
	    }
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror (YY_("syntax error"));
    }

  yyerror_range[0] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse look-ahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
        {
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
        }
      else
	{
	  yydestruct ("Error: discarding", yytoken, &yylval, &yylloc);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse look-ahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (0)
     goto yyerrorlab;

  yyerror_range[0] = yylsp[1-yylen];
  yylsp -= yylen;
  yyvsp -= yylen;
  yyssp -= yylen;
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      yyerror_range[0] = *yylsp;
      yydestruct ("Error: popping", yystos[yystate], yyvsp, yylsp);
      YYPOPSTACK;
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  *++yyvsp = yylval;

  yyerror_range[1] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the look-ahead.  YYLOC is available though. */
  YYLLOC_DEFAULT (yyloc, yyerror_range - 1, 2);
  *++yylsp = yyloc;

  /* Shift the error token. */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEOF && yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval, &yylloc);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp, yylsp);
      YYPOPSTACK;
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 633 "/mercury_home/skr_local/RELEASE_0.85_CAN/tpd_parser/tell_yacc.yy"

/*-------------------------------------------------------------------------*/
int yyerror (char *s) {  /* Called by yyparse on error */
   std::ostringstream ost;
   ost << "line " << telllloc.first_line << ": col " << telllloc.first_column
       << ": " << s;
   tell_log(console::MT_ERROR,ost.str());
   return 0;
}

void tellerror (std::string s, YYLTYPE loc) {
   if (NULL != arglist) funcdeferrors++;
   else                 yynerrs++;
   std::ostringstream ost;
   ost << "line " << loc.first_line << ": col " << loc.first_column << ": ";
   if (loc.filename) {
      std::string fn = loc.filename;
      ost << "in file \"" << fn << "\" : ";
   }
   ost << s;
   tell_log(console::MT_ERROR,ost.str());
}

void tellerror (std::string s) {
   if (NULL != arglist) funcdeferrors++;
   else                 yynerrs++;
   std::ostringstream ost;
   ost << "line " << telllloc.first_line << ": col " << telllloc.first_column << ": " << s;
   tell_log(console::MT_ERROR,ost.str());
}
// 
// {
//          /*Check whether such a function is already defined */
//          if (NULL != CMDBlock->funcDefined($2,arglist)) {
//             tellerror("function already defined",@$);
//             delete [] $2;
//             parsercmd::ClearArgumentList(arglist); delete(arglist); arglist = NULL;
//             YYABORT;
// }
// }

